#include <grx20.h>

#define Transparent   0xFFFFFFFFL

  #define Black         0x00000000L
  #define White         0x00FFFFFFL
  #define Blue          0x000000FFL
  #define Yellow        0x00FFFF00L
  #define Green         0x0000FF00L
  #define Magenta       0x00FF00FFL
  #define Red           0x00FF0000L
  #define Cyan          0x0000FFFFL

  #define Grey          0x00808080L
  #define Gray          0x00808080L
  #define LightGrey     0x00C0C0C0L
  #define LightGray     0x00C0C0C0L
  #define DarkGrey      0x00404040L
  #define DarkGray      0x00404040L

  #define DarkBlue      0x00000080L
  #define DarkGreen     0x00008000L
  #define DarkRed       0x00800000L
  #define LightBlue     0x0080C0FFL
  #define LightGreen    0x0080FF80L
  #define LightRed      0x00FFC0FFL
  #define Pink          0x00FFAFAFL
  #define Brown         0x00603000L
  #define Orange        0x00FF8000L
  #define Purple        0x00C000FFL
  #define Lime          0x0080FF00L

typedef GrColor rgb;
typedef struct point  point;

  struct point {
    int x;      /* horizontal co-ordinate */
    int y;      /* vertical co-ordinate */
  };

typedef struct rect  rect;

  struct rect {
    int x, y;           /* top-left point inside rectangle */
    int width, height;  /* pixel width and height of rectangle */
  };

typedef unsigned char byte;

rect initrect(int x, int y, int w, int h);
void fillellipse(rect r);
void setcolour(GrColor c);
void init();
rect insetr(rect r, int n);
void setlinewidth(int w);
void drawarc(rect r, int start, int end);
void drawline(point p1, point p2);
void drawpoint(point p);
point pt(int x, int y);
void fillrect(rect r);
