// Very machine specific
// Ben Lin 10/98
#include <stdio.h>
#include <dos.h>
#include <pc.h>
#include <sys/movedata.h>
#include <sys/segments.h>
#include <sys/nearptr.h>
#include <dpmi.h>

#define randomize() (srand((unsigned) time(NULL)))

typedef unsigned char byte;

enum {
	wsize = 65536,
	swidth = 640,
	sheight = 480,
	PALSIZE = 768
};

char img[swidth * sheight];

int main() {
	unsigned char origpal[PALSIZE], curpal[PALSIZE];
	int i, j;
	int addr;
	//union REGS r;
	//struct SREGS sr;
	__dpmi_regs r;
	byte buf[1000];
	int scratchsel;
	int scratchseg;
	int gran, granmult;

	scratchseg = __dpmi_allocate_dos_memory(32, &scratchsel);

	r.x.ax = 0x4F00;
	//r.x.es = _my_ds();
	r.x.es = scratchseg;
	r.x.di = 0;
	__dpmi_int(0x10, &r);
	addr = r.x.es * 16;
	dosmemget(addr, 512, buf);

	r.x.ax = 0x4F01;
	r.x.cx = 0x101;
	r.x.es = scratchseg;
	r.x.di = 0;
	__dpmi_int(0x10, &r);
	dosmemget(addr, 256, buf);

	//printf("A: %x B: ", buf[2]);
	//printf("%x\n", buf[3]);
	gran = buf[4] + 256 * buf[5];
	granmult = 64 / gran;
	//printf("Gran: %d\n", gran);
	//printf("Aseg: %x\n", buf[8] + 256 * buf[9]);
	//printf("Bseg: %x\n", buf[10] + 256 * buf[11]);

	getchar();

	/*
	r.x.ax = 0x13;
	__dpmi_int(0x10, &r);
	*/

	r.x.ax = 0x4F02;
	r.x.bx = 0x101;
	__dpmi_int(0x10, &r);

	outportb(0x3c8, 0);
	for (i=0; i<256; i++) {
		outportb(0x3c9, (byte) (((i & 0xE0) >> 5) * 8) + 7);
		outportb(0x3c9, (byte) (((i & 0x1C) >> 2) * 8) + 7);
		outportb(0x3c9, (byte) ((i & 0x3) * 16) + 15);
	}

	for (i=0; i<swidth * sheight; i++) img[i] = 0;

	for (i=0; i<256; i++) {
		for (j=0; j<sheight; j++) {
			img[j * swidth + i] = (byte) i;
		}
	}

	for (i=0; i<=swidth * sheight / wsize; i++) {
		r.x.ax = 0x4F05;
		r.x.bx = 0;
		r.x.dx = i * granmult;
		__dpmi_int(0x10, &r);
		dosmemput(&img[i * wsize], wsize, 0xA0000);
	}

	r.x.ax = 0x4F05;
	r.x.bx = 0x100;
	__dpmi_int(0x10, &r);

	getchar();

	r.x.ax = 3;
	__dpmi_int(0x10, &r);

	__dpmi_free_dos_memory(scratchsel);

	return(0);
}
